--- old/usr/src/lib/libdladm/common/libdlwlan.c	2012-06-12 19:54:54.906974412 +0200
+++ new/usr/src/lib/libdladm/common/libdlwlan.c	2012-06-12 19:54:54.929856467 +0200
@@ -1578,402 +1461,275 @@
 	}
 	mlme.im_reason = reason;
 	if (bssid != NULL)
-		(void) memcpy(mlme.im_macaddr, bssid->wb_bytes,
-		    DLADM_WLAN_BSSID_LEN);
+	    memcpy(mlme.im_macaddr, bssid, DLADM_WLAN_BSSID_LEN);
 
 	return (i_dladm_wlan_param(handle, linkid, &mlme, MAC_PROP_WL_MLME,
 	    sizeof (mlme), B_TRUE));
 }
 
-/*
- * routines of create instance
- */
-static scf_propertygroup_t *
-add_property_group_to_instance(scf_handle_t *handle, scf_instance_t *instance,
-    const char *pg_name, const char *pg_type)
-{
-	scf_propertygroup_t *pg;
-
-	pg = scf_pg_create(handle);
-	if (pg == NULL)
-		return (NULL);
-
-	if (scf_instance_add_pg(instance, pg_name, pg_type, 0, pg) != 0) {
-		scf_pg_destroy(pg);
-		return (NULL);
-	}
-
-	return (pg);
-}
-
-static dladm_status_t
-add_new_property(scf_handle_t *handle, const char *prop_name,
-    scf_type_t type, const char *val, scf_transaction_t *tx)
+ /*
+  * This routine is used for opening a control interface to wpa_supplicant
+  * global interface ctrl_path, /var/run/wpa_supplicant-global. This path
+  * is configured in network/wpa_supplicant service manifest.
+  * network/wpa_supplicant service must be running.
+  */
+static int
+wpa_instance_create(char *ifname)
 {
-	scf_value_t *value = NULL;
-	scf_transaction_entry_t *entry = NULL;
-
-	entry = scf_entry_create(handle);
-	if (entry == NULL)
-		goto out;
+	struct wpa_ctrl *ctrl_global;
+	const char *global_path = CTRL_IFACE_GLOBAL;
 
-	value = scf_value_create(handle);
-	if (value == NULL)
-		goto out;
+	/*
+	 * When we'll have a configuration backend that supports know_wlans.conf
+	 * we could add this file direclty in the third parameter
+	 */
+	char *interface_add[] = {"interface_add", ifname, """", "solaris",
+	    CTRL_IFACE_DIR};
 
-	if (scf_transaction_property_new(tx, entry, prop_name, type) != 0)
-		goto out;
+	if (ifname == NULL)
+		return -1;
 
-	if (scf_value_set_from_string(value, type, val) != 0)
-		goto out;
+	ctrl_global = wpa_ctrl_open(global_path);
+	if (ctrl_global == NULL) {
+		return -1;
+	}
 
-	if (scf_entry_add_value(entry, value) != 0)
-		goto out;
+	if (wpa_request(ctrl_global, 5, interface_add))
+		return -1;
 
-	return (DLADM_STATUS_OK);
+	wpa_ctrl_close(ctrl_global);
 
-out:
-	if (value != NULL)
-		scf_value_destroy(value);
-	if (entry != NULL)
-		scf_entry_destroy(entry);
+	/* wpa_s now executes wpa_driver_solaris_init */
 
-	return (DLADM_STATUS_FAILED);
+	return 0;
 }
 
-static dladm_status_t
-add_pg_method(scf_handle_t *handle, scf_instance_t *instance,
-    const char *pg_name, const char *flags)
+static int
+wpa_instance_delete(char *ifname)
 {
-	int			rv, size;
-	dladm_status_t		status = DLADM_STATUS_FAILED;
-	char			*command = NULL;
-	scf_transaction_t	*tran = NULL;
-	scf_propertygroup_t	*pg;
-
-	pg = add_property_group_to_instance(handle, instance,
-	    pg_name, SCF_GROUP_METHOD);
-	if (pg == NULL)
-		goto out;
-
-	tran = scf_transaction_create(handle);
-	if (tran == NULL)
-		goto out;
-
-	size = strlen(SVC_METHOD) + strlen("  ") + strlen(flags) + 1;
-	command = malloc(size);
-	if (command == NULL) {
-		status = DLADM_STATUS_NOMEM;
-		goto out;
-	}
-	(void) snprintf(command, size, "%s %s", SVC_METHOD, flags);
+	/*struct wpa_ctrl *ctrl_conn;*/
+	struct wpa_ctrl *ctrl_global;
 
-	do {
-		if (scf_transaction_start(tran, pg) != 0)
-			goto out;
-
-		if (add_new_property(handle, SCF_PROPERTY_EXEC,
-		    SCF_TYPE_ASTRING, command, tran) != DLADM_STATUS_OK) {
-			goto out;
-		}
-
-		rv = scf_transaction_commit(tran);
-		switch (rv) {
-		case 1:
-			status = DLADM_STATUS_OK;
-			goto out;
-		case 0:
-			scf_transaction_destroy_children(tran);
-			if (scf_pg_update(pg) == -1) {
-				goto out;
-			}
-			break;
-		case -1:
-		default:
-			goto out;
-		}
-	} while (rv == 0);
-
-out:
-	if (tran != NULL) {
-		scf_transaction_destroy_children(tran);
-		scf_transaction_destroy(tran);
-	}
+	const char *global_path = CTRL_IFACE_GLOBAL;
+	/*char *cfile = NULL;*/
+	char *interface_remove[] = {"interface_remove", ifname};
+	/* char *cmd_disconnect[] = {"disconnect"}; */
+	/* int flen, res;*/
 
-	if (pg != NULL)
-		scf_pg_destroy(pg);
+	if (ifname == NULL)
+		return -1;
 
-	if (command != NULL)
-		free(command);
-
-	return (status);
-}
+/*
 
-static dladm_status_t
-do_create_instance(scf_handle_t *handle, scf_service_t *svc,
-    const char *instance_name, const char *command)
-{
-	dladm_status_t status = DLADM_STATUS_FAILED;
-	char *buf;
-	ssize_t max_fmri_len;
-	scf_instance_t *instance;
-
-	instance = scf_instance_create(handle);
-	if (instance == NULL)
-		goto out;
-
-	if (scf_service_add_instance(svc, instance_name, instance) != 0) {
-		if (scf_error() == SCF_ERROR_EXISTS)
-			/* Let the caller deal with the duplicate instance */
-			status = DLADM_STATUS_EXIST;
-		goto out;
-	}
-
-	if (add_pg_method(handle, instance, "start",
-	    command) != DLADM_STATUS_OK) {
-		goto out;
-	}
-
-	/* enabling the instance */
-	max_fmri_len = scf_limit(SCF_LIMIT_MAX_FMRI_LENGTH);
-	if ((buf = malloc(max_fmri_len + 1)) == NULL)
-		goto out;
-
-	if (scf_instance_to_fmri(instance, buf, max_fmri_len + 1) > 0) {
-		if ((smf_disable_instance(buf, 0) != 0) ||
-		    (smf_enable_instance(buf, SMF_TEMPORARY) != 0)) {
-			goto out;
+	 * Get the instance name of the existing control interface.
+	 * Control interface will use the link name as the UNIX socket filename
+	 * in CTRL_IFACE_DIR
+
+	if (cfile == NULL) {
+		flen = strlen(CTRL_IFACE_DIR) + strlen(ifname) + 2;
+		cfile = malloc(flen);
+		if (cfile == NULL)
+			return -1;
+		res = snprintf(cfile, flen, "%s/%s", CTRL_IFACE_DIR, ifname);
+		if (res < 0 || res >= flen) {
+			free(cfile);
+			return -1;
 		}
-		status = DLADM_STATUS_OK;
 	}
 
-out:
-	if (instance != NULL)
-		scf_instance_destroy(instance);
-	return (status);
-}
-
-static dladm_status_t
-create_instance(const char *instance_name, const char *command)
-{
-	dladm_status_t status = DLADM_STATUS_FAILED;
-	scf_service_t *svc = NULL;
-	scf_handle_t *handle = NULL;
-
-	handle = scf_handle_create(SCF_VERSION);
-	if (handle == NULL)
-		goto out;
-
-	if (scf_handle_bind(handle) == -1)
-		goto out;
+	ctrl_conn = wpa_ctrl_open(cfile);
 
-	if ((svc = scf_service_create(handle)) == NULL)
-		goto out;
+	free(cfile);
 
-	if (scf_handle_decode_fmri(handle, SERVICE_NAME, NULL, svc,
-	    NULL, NULL, NULL, SCF_DECODE_FMRI_EXACT) != 0)
-		goto out;
+	if (ctrl_conn == NULL)
+		return -1;
 
-	status = do_create_instance(handle, svc, instance_name, command);
+	if (wpa_request(ctrl_conn, 1, cmd_disconnect))
+		return -1;
 
-out:
-	if (svc != NULL)
-		scf_service_destroy(svc);
+	wpa_ctrl_close(ctrl_conn);
+*/
 
-	if (handle != NULL) {
-		(void) scf_handle_unbind(handle);
-		scf_handle_destroy(handle);
+	/* remove interface */
+	ctrl_global = wpa_ctrl_open(global_path);
+	if (ctrl_global == NULL) {
+		return -1;
 	}
 
-	return (status);
-}
+	if (wpa_request(ctrl_global, 2, interface_remove))
+		return -1;
 
-/*
- * routines of delete instance
- */
-#define	DEFAULT_TIMEOUT	60000000
-#define	INIT_WAIT_USECS	50000
+	wpa_ctrl_close(ctrl_global);
 
-static void
-wait_until_disabled(scf_handle_t *handle, char *fmri)
-{
-	char		*state;
-	useconds_t	max;
-	useconds_t	usecs;
-	uint64_t	*cp = NULL;
-	scf_simple_prop_t *sp = NULL;
-
-	max = DEFAULT_TIMEOUT;
-
-	if (((sp = scf_simple_prop_get(handle, fmri, "stop",
-	    SCF_PROPERTY_TIMEOUT)) != NULL) &&
-	    ((cp = scf_simple_prop_next_count(sp)) != NULL) && (*cp != 0))
-		max = (*cp) * 1000000;	/* convert to usecs */
-
-	if (sp != NULL)
-		scf_simple_prop_free(sp);
-
-	for (usecs = INIT_WAIT_USECS; max > 0; max -= usecs) {
-		/* incremental wait */
-		usecs *= 2;
-		usecs = (usecs > max) ? max : usecs;
-
-		(void) usleep(usecs);
-
-		/* Check state after the wait */
-		if ((state = smf_get_state(fmri)) != NULL) {
-			if (strcmp(state, "disabled") == 0)
-				return;
-		}
-	}
+	return 0;
 }
 
-static dladm_status_t
-delete_instance(const char *instance_name)
-{
-	dladm_status_t	status = DLADM_STATUS_FAILED;
-	char		*buf;
-	ssize_t		max_fmri_len;
-	scf_scope_t	*scope = NULL;
-	scf_service_t	*svc = NULL;
-	scf_handle_t	*handle = NULL;
-	scf_instance_t	*instance;
-
-	handle = scf_handle_create(SCF_VERSION);
-	if (handle == NULL)
-		goto out;
-
-	if (scf_handle_bind(handle) == -1)
-		goto out;
-
-	if ((scope = scf_scope_create(handle)) == NULL)
-		goto out;
+#define MAC2STR(a) (a)[0], (a)[1], (a)[2], (a)[3], (a)[4], (a)[5]
+#define MACSTR "%02x:%02x:%02x:%02x:%02x:%02x"
 
-	if ((svc = scf_service_create(handle)) == NULL)
-		goto out;
-
-	if (scf_handle_get_scope(handle, SCF_SCOPE_LOCAL, scope) == -1)
-		goto out;
-
-	if (scf_scope_get_service(scope, SERVICE_NAME, svc) < 0)
-		goto out;
-
-	instance = scf_instance_create(handle);
-	if (instance == NULL)
-		goto out;
-
-	if (scf_service_get_instance(svc, instance_name, instance) != 0) {
-		scf_error_t scf_errnum = scf_error();
+static int wpa_network_config(char *ifname, dladm_wlan_attr_t *attrp,
+	dladm_wlan_key_t *keys, boolean_t *create_ibss, char *identity)
+{
+	struct wpa_ctrl *ctrl_conn;
 
-		if (scf_errnum == SCF_ERROR_NOT_FOUND)
-			status = DLADM_STATUS_OK;
+	char *cfile = NULL;
+	int i, flen, res;
 
-		scf_instance_destroy(instance);
-		goto out;
-	}
+	char *ap_scan[] = {"ap_scan", "1"};
+	char *add_network[] = {"add_network"};
+	char *enable_network[] = {"enable_network", "0"};
+	char *set_network[] = {"set_network", "0", NULL, NULL };
+	char *network_props[] = { "ssid", "key_mgmt", "pairwise", "group",
+	    "auth_alg", "proto"};
+	char *network_vals[6];
+	char *hexascii = NULL;
+	char ap_bssid[DLADM_WLAN_BSSID_LEN*3];
+	char *cmd_bssid[] = { "bssid", "0", ap_bssid };
 
-	max_fmri_len = scf_limit(SCF_LIMIT_MAX_FMRI_LENGTH);
-	if ((buf = malloc(max_fmri_len + 1)) == NULL) {
-		scf_instance_destroy(instance);
-		goto out;
-	}
+	if (ifname == NULL)
+		return -1;
 
-	if (scf_instance_to_fmri(instance, buf, max_fmri_len + 1) > 0) {
-		char *state;
+	for (i=0; i<6; i++)
+		network_vals[1] = NULL;
 
-		state = smf_get_state(buf);
-		if (state && (strcmp(state, SCF_STATE_STRING_ONLINE) == 0 ||
-		    strcmp(state, SCF_STATE_STRING_DEGRADED) == 0)) {
-			if (smf_disable_instance(buf, 0) == 0) {
-				/*
-				 * Wait for some time till timeout to avoid
-				 * a race with scf_instance_delete() below.
-				 */
-				wait_until_disabled(handle, buf);
-			}
+	/*
+	 * Control interface will use the link name as the UNIX socket filename
+	 * in CTRL_IFACE_DIR
+	 */
+	if (cfile == NULL) {
+		flen = strlen(CTRL_IFACE_DIR) + strlen(ifname) + 2;
+		cfile = malloc(flen);
+		if (cfile == NULL)
+			return -1;
+		res = snprintf(cfile, flen, "%s/%s", CTRL_IFACE_DIR, ifname);
+		if (res < 0 || res >= flen) {
+			free(cfile);
+			return -1;
 		}
 	}
 
-	if (scf_instance_delete(instance) != 0) {
-		scf_instance_destroy(instance);
-		goto out;
-	}
+	ctrl_conn = wpa_ctrl_open(cfile);
+	free(cfile);
 
-	scf_instance_destroy(instance);
+	if (ctrl_conn == NULL)
+		return -1;
 
-	status = DLADM_STATUS_OK;
+	/* set ap_scan=2 */
+	if (wpa_request(ctrl_conn, 2, ap_scan))
+		return -1;
+
+	/* add empty wifi network block */
+	(void) wpa_request(ctrl_conn, 1, add_network);
+
+	/* leave bssid out if strict_bssid=false?*/
+	snprintf(ap_bssid, 3 * DLADM_WLAN_BSSID_LEN, MACSTR,
+	    MAC2STR(attrp->wa_bssid.wb_bytes));
+	(void) wpa_request(ctrl_conn, 3, cmd_bssid);
+
+	/* ssid string needs to be quoted */
+	network_vals[0] = malloc(attrp->wa_essid.we_length + 3);
+	snprintf(network_vals[0], attrp->wa_essid.we_length + 3, "\"%s\"",
+	    attrp->wa_essid.we_bytes);
+	/* we will add support for static WEP config. with wpa_s later */
+	network_vals[4] = (char*)dladm_wlan_auth2str(&attrp->wa_auth, malloc(5));
 
-out:
-	if (svc != NULL)
-		scf_service_destroy(svc);
-
-	if (scope != NULL)
-		scf_scope_destroy(scope);
-
-	if (handle != NULL) {
-		(void) scf_handle_unbind(handle);
-		scf_handle_destroy(handle);
-	}
-
-	return (status);
-}
-
-static dladm_status_t
-wpa_instance_create(dladm_handle_t handle, datalink_id_t linkid, void *key)
-{
-	dladm_status_t	status = DLADM_STATUS_FAILED;
-	char		*command = NULL;
-	char		*wk_name = ((dladm_wlan_key_t *)key)->wk_name;
-	int		size;
-	char		instance_name[MAXLINKNAMELEN];
+	/*
+	if (*create_ibss) {
+		network_vals[1]="WPA-NONE";
+		network_vals[2]="NONE";
+		network_vals[3]="TKIP";
+		network_vals[5]="WPA";
+		 * mode=1
+		 * frequency=2412
+		 * psk="secret passphrase"
+		 * ssid="test adhoc"
+	} else {
+		network_vals[1] = wpa_key_mgmt_txt(attrp->wa_ie.key_mgmt);
+		network_vals[2] = wpa_cipher_txt(attrp->wa_ie.pairwise_cipher);
+		network_vals[3] = wpa_cipher_txt(attrp->wa_ie.group_cipher);
+		network_vals[5] = ((attrp->wa_ie.proto == 2) ? "RSN" : "WPA");
+	}
+
+	for (i=0; i<6; i++) {
+		set_network[2] = network_props[i];
+		set_network[3] = network_vals[i];
+		(void) wpa_request(ctrl_conn, 4, set_network);
+	} */
+
+	set_network[2] = network_props[0];
+	set_network[3] = network_vals[0];
+	wpa_request(ctrl_conn, 4, set_network);
+	free(network_vals[0]);
+	free(network_vals[4]);
 
 	/*
-	 * Use the link name as the instance name of the network/wpad service.
+	 * If we use hexascii strings, wpa_s does not require quotation, and
+	 * we would be able to pass it directly to wpa_request.
+	 * Currently getsecobj returns the string value, not hexascii
 	 */
-	status = dladm_datalink_id2info(handle, linkid, NULL, NULL, NULL,
-	    instance_name, sizeof (instance_name));
-	if (status != DLADM_STATUS_OK)
-		goto out;
-
-	size = strlen(instance_name) + strlen(" -i  -k ") + strlen(wk_name) + 1;
-	command = malloc(size);
-	if (command == NULL) {
-		status = DLADM_STATUS_NOMEM;
-		goto out;
-	}
-	(void) snprintf(command, size, "-i %s -k %s", instance_name, wk_name);
+	hexascii = malloc(keys->wk_len + 3);
+	snprintf(hexascii, keys->wk_len + 3, "\"%s\"", keys->wk_val);
 
-	status = create_instance(instance_name, command);
-	if (status == DLADM_STATUS_EXIST) {
-		/*
-		 * Delete the existing instance and create a new instance
-		 * with the supplied arguments.
+	if (keys->wk_class == DLADM_SECOBJ_CLASS_PSK) {
+		set_network[2] = "psk";
+		set_network[3] = hexascii;
+		(void) wpa_request(ctrl_conn, 4, set_network);
+	} else {
+		char *cmd_eap[] = {"set_network", "0", "eap", NULL};
+		set_network[2] = "identity";
+		set_network[3] = identity;
+		(void) wpa_request(ctrl_conn, 4, set_network);
+		set_network[2] = "ca_cert";
+		set_network[3] = "\"/etc/cert/ca.pem\"";
+		(void) wpa_request(ctrl_conn, 4, set_network);
 		 */
-		if ((status = delete_instance(instance_name)) ==
-		    DLADM_STATUS_OK) {
-			status = create_instance(instance_name, command);
+		if (keys->wk_class == DLADM_SECOBJ_CLASS_TLS) {
+			char *tls_props[] = {"engine", "engine_id", "key_id",
+			    "pin", "client_cert"};
+			char *tls_vals[] = {"1", "pkcs11", "TODO", hexascii,
+			    "DEFAULT_PATH"};
+			cmd_eap[3] = "TLS";
+			(void) wpa_request(ctrl_conn, 4, cmd_eap);
+			for (i=0; i<6; i++) {
+				char *cmd_tls[] = {"set_network", "0",
+				    tls_props[i], tls_vals[i]};
+				(void) wpa_request(ctrl_conn, 4, cmd_tls);
+			}
+		} else {
+			set_network[2] = "password";
+		    	set_network[3] = hexascii;
+			(void) wpa_request(ctrl_conn, 4, set_network);
+			if (keys->wk_class == DLADM_SECOBJ_CLASS_TTLS) {
+				cmd_eap[3] = "TTLS";
+				(void) wpa_request(ctrl_conn, 4, cmd_eap);
+				/* optional
+				set_network[2] = "anonymous_identity";
+				set_network[3] = "DEFAULT_ANONYMOUS";
+				(void) wpa_request(ctrl_conn, 4, set_network);*/
+				set_network[2] = "phase2";
+		    		set_network[3] = "\"auth=PAP\"";
+		    		/*
+		    		 * other possible values are: auth=MSCHAPV2 auth=MD5;
+				 * we do not support autheap=TLS for eap-ttls
+				 */
+				(void) wpa_request(ctrl_conn, 4, set_network);
+			} else {
+				cmd_eap[3] = "PEAP";
+				(void) wpa_request(ctrl_conn, 4, cmd_eap);
+				set_network[2] = "phase2";
+		    		set_network[3] = "\"auth=MSCHAPV2\"";
+				(void) wpa_request(ctrl_conn, 4, set_network);
+			}
 		}
 	}
-
-out:
-	if (command != NULL)
-		free(command);
-
-	return (status);
-}
-
-static dladm_status_t
-wpa_instance_delete(dladm_handle_t handle, datalink_id_t linkid)
-{
-	char	instance_name[MAXLINKNAMELEN];
-
+	(void) wpa_request(ctrl_conn, 2, enable_network);
 	/*
-	 * Get the instance name of the network/wpad service (the same as
-	 * the link name).
+	 * the wpa_s driver interface starts interacting with net80211 module
 	 */
-	if (dladm_datalink_id2info(handle, linkid, NULL, NULL, NULL,
-	    instance_name, sizeof (instance_name)) != DLADM_STATUS_OK)
-		return (DLADM_STATUS_FAILED);
 
-	return (delete_instance(instance_name));
+	wpa_ctrl_close(ctrl_conn);
+
+	free(hexascii);
+
+	return 0;
 }
